#include <stdio.h>

#define TRACE_DEBUG

#include "pogohash.inc"

int main(int argc, char **argv)
{
  int i, j;

  fprintf(stdout, "PogoHash\n");
  fprintf(stdout, "--------\n");
  fprintf(stdout, "\n");

  fprintf(stdout, ":: init()\n");
  fprintf(stdout, "%s\n", POGO_FILENAME);
  POGO_init(); 

  {
    uint64_t result;
    uint8_t  buffer[256] = {0};
    buffer[0] = 0x61;
    buffer[1] = 0x24;
    buffer[2] = 0x7f;
    buffer[3] = 0xbf;
    j = 28;              // locationHash2 with lat, long, alt = 0

/**
    j = 0;   // trip ROUND_MAGIC, FINAL_MAGIC2, FINAL_MAGIC1
    j = 1;   // trip magic_table[00], magic_table[01] 
    j = 17;  // trip magic_table[02], magic_table[03]
    j = 33;  // trip magic_table[04], magic_table[05]
    j = 49;  // trip magic_table[06], magic_table[07]
    j = 65;  // trip magic_table[08], magic_table[09]
    j = 81;  // trip magic_table[10], magic_table[11]
    j = 97;  // trip magic_table[12], magic_table[13]
    j = 113; // trip magic_table[14], magic_table[15]
**/

    {
      // real request from @marcel (dump of values pointed by r0 on device)
      // (lldb) memory read -c256 0x414194f4
      uint8_t req[0xc0] = {
         0x29, 0x01, 0x00, 0x00, 0x08, 0x02, 0xff, 0xff, 
         0xb8, 0x96, 0x41, 0x41, 0x3f, 0x01, 0x00, 0x00,
         0x87, 0x49, 0x00, 0x00, 0x5c, 0x95, 0x41, 0x41, 
         0x28, 0x95, 0x41, 0x41, 0x78, 0x95, 0x41, 0x41,
         0x5c, 0x95, 0x41, 0x41, 0x00, 0x00, 0x00, 0x00, 
         0x28, 0x95, 0x41, 0x41, 0x18, 0x98, 0x41, 0x41,
         0x70, 0x95, 0x41, 0x41, 0x18, 0x64, 0x07, 0x36, 
         0x28, 0x64, 0x07, 0x36, 0x3c, 0xf3, 0x56, 0x28,
         0x80, 0x9c, 0xf2, 0x19, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x54, 0x14, 0x81, 0x07, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00,
         0xa2, 0xab, 0xaa, 0x32, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
         0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00
      };
      uint32_t v, _v;
      int      ofs;
      uint8_t  _buffer[256] = {0};

      // 47.1s
      j = 0xc0;
      for (i=0; i<j; i++)
        buffer[i] = req[i];

      fprintf(stdout, "buffer[] :: before\n");
      for (i=0; i<j>>2; i++)
      {
        ofs = i * 4;;
        v = *((uint32_t *)( buffer + ofs));  
        fprintf(stdout, "[0x%02x] val: 0x%08x\n", ofs, v);
      }     

      // [mem-r] len:4 at 0xe0000008  -- b8 96 41 41
      // [mem-r] len:4 at 0xe000000c  -- 3f 01 00 00
      // [mem-r] len:4 at 0xe0000020  -- 5c 95 41 41
      // [mem-r] len:4 at 0xe0000024  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000028  -- 28 95 41 41
      // [mem-r] len:4 at 0xe000002c  -- 18 98 41 41
      // [mem-r] len:4 at 0xe0000030  -- 70 95 41 41
      // [mem-r] len:4 at 0xe0000034  -- 18 64 07 36
      // [mem-r] len:4 at 0xe0000040  -- 80 9c f2 19
      // [mem-r] len:4 at 0xe0000044  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000050  -- 54 14 81 07
      // [mem-r] len:4 at 0xe0000054  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000058  -- 00 00 00 00
      // [mem-r] len:4 at 0xe000005c  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000068  -- 00 00 00 00
      // [mem-r] len:4 at 0xe000006c  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000078  -- 00 00 00 36
      // [mem-r] len:4 at 0xe000007c  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000080  -- a2 ab aa 32
      // [mem-r] len:4 at 0xe0000084  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000088  -- 00 00 00 00
      // [mem-r] len:4 at 0xe000008c  -- 00 00 00 00
      // [mem-r] len:4 at 0xe0000098  -- 00 00 00 00
      // [mem-r] len:4 at 0xe000009c  -- 00 00 00 00
      // [mem-r] len:4 at 0xe00000a0  -- 00 00 00 00
      // [mem-r] len:4 at 0xe00000a4  -- 00 00 00 00
      // [mem-r] len:4 at 0xe00000b8  -- 80 0b 10 46
      // [mem-r] len:4 at 0xe00000bc  -- 5f 00 00 00

      // make a copy of the buffer
      for (i=0; i<j; i++)
        _buffer[i] = buffer[i];

      fprintf(stdout, "done\n");
      fprintf(stdout, "Hash(buffer)\n");
      result = Hash(buffer, j);
      fprintf(stdout, "done\n");

      // which values changed?
      fprintf(stdout, "buffer[] :: changes after\n");
      for (i=0; i<j>>2; i++)
      {
        ofs = i * 4;;
         v = *((uint32_t *)( buffer + ofs));  
        _v = *((uint32_t *)(_buffer + ofs));  
        if (v != _v)
        {
          fprintf(stdout, "[0x%02x] old: 0x%08x new 0x%08x\n", ofs, _v, v);
        }
      }
      fprintf(stdout, "done\n");

      fprintf(stdout, ":: Hash(buffer, sizeof(buffer)) [iOS code]\n");
      {
        for (i=0; i<j; i++)
          fprintf(stdout, "%02x ", (_buffer[i] & 0xff));
        fprintf(stdout, "len=%2d\n", j);

        printf("0x%08lx\n", result);
      }
      fprintf(stdout, "done\n");
    }
  }

  fprintf(stdout, ":: quit()\n");
  POGO_quit();
  fprintf(stdout, "done\n");

  return 0;
}
